// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/LoadCarrierModel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/load_carrier_model__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
// Member `type`
// Member `pose_type`
#include "rosidl_runtime_c/string_functions.h"
// Member `outer_dimensions`
// Member `inner_dimensions`
#include "rc_reason_msgs/msg/detail/box__functions.h"
// Member `rim_thickness`
// Member `rim_ledge`
#include "rc_reason_msgs/msg/detail/rectangle__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"

bool
rc_reason_msgs__msg__LoadCarrierModel__init(rc_reason_msgs__msg__LoadCarrierModel * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->outer_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->inner_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rim_thickness)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // rim_step_height
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rim_ledge)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  // pose_type
  if (!rosidl_runtime_c__String__init(&msg->pose_type)) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierModel__fini(rc_reason_msgs__msg__LoadCarrierModel * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // outer_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->outer_dimensions);
  // inner_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->inner_dimensions);
  // rim_thickness
  rc_reason_msgs__msg__Rectangle__fini(&msg->rim_thickness);
  // rim_step_height
  // rim_ledge
  rc_reason_msgs__msg__Rectangle__fini(&msg->rim_ledge);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // pose_type
  rosidl_runtime_c__String__fini(&msg->pose_type);
}

bool
rc_reason_msgs__msg__LoadCarrierModel__are_equal(const rc_reason_msgs__msg__LoadCarrierModel * lhs, const rc_reason_msgs__msg__LoadCarrierModel * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__are_equal(
      &(lhs->outer_dimensions), &(rhs->outer_dimensions)))
  {
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__are_equal(
      &(lhs->inner_dimensions), &(rhs->inner_dimensions)))
  {
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__are_equal(
      &(lhs->rim_thickness), &(rhs->rim_thickness)))
  {
    return false;
  }
  // rim_step_height
  if (lhs->rim_step_height != rhs->rim_step_height) {
    return false;
  }
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__are_equal(
      &(lhs->rim_ledge), &(rhs->rim_ledge)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // pose_type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->pose_type), &(rhs->pose_type)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__LoadCarrierModel__copy(
  const rc_reason_msgs__msg__LoadCarrierModel * input,
  rc_reason_msgs__msg__LoadCarrierModel * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__copy(
      &(input->outer_dimensions), &(output->outer_dimensions)))
  {
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__copy(
      &(input->inner_dimensions), &(output->inner_dimensions)))
  {
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__copy(
      &(input->rim_thickness), &(output->rim_thickness)))
  {
    return false;
  }
  // rim_step_height
  output->rim_step_height = input->rim_step_height;
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__copy(
      &(input->rim_ledge), &(output->rim_ledge)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // pose_type
  if (!rosidl_runtime_c__String__copy(
      &(input->pose_type), &(output->pose_type)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__LoadCarrierModel *
rc_reason_msgs__msg__LoadCarrierModel__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierModel * msg = (rc_reason_msgs__msg__LoadCarrierModel *)allocator.allocate(sizeof(rc_reason_msgs__msg__LoadCarrierModel), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__LoadCarrierModel));
  bool success = rc_reason_msgs__msg__LoadCarrierModel__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__LoadCarrierModel__destroy(rc_reason_msgs__msg__LoadCarrierModel * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__LoadCarrierModel__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__LoadCarrierModel__Sequence__init(rc_reason_msgs__msg__LoadCarrierModel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierModel * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__LoadCarrierModel *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__LoadCarrierModel), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__LoadCarrierModel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__LoadCarrierModel__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierModel__Sequence__fini(rc_reason_msgs__msg__LoadCarrierModel__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__LoadCarrierModel__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__LoadCarrierModel__Sequence *
rc_reason_msgs__msg__LoadCarrierModel__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierModel__Sequence * array = (rc_reason_msgs__msg__LoadCarrierModel__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__LoadCarrierModel__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__LoadCarrierModel__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__LoadCarrierModel__Sequence__destroy(rc_reason_msgs__msg__LoadCarrierModel__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__LoadCarrierModel__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__LoadCarrierModel__Sequence__are_equal(const rc_reason_msgs__msg__LoadCarrierModel__Sequence * lhs, const rc_reason_msgs__msg__LoadCarrierModel__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__LoadCarrierModel__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__LoadCarrierModel__Sequence__copy(
  const rc_reason_msgs__msg__LoadCarrierModel__Sequence * input,
  rc_reason_msgs__msg__LoadCarrierModel__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__LoadCarrierModel);
    rc_reason_msgs__msg__LoadCarrierModel * data =
      (rc_reason_msgs__msg__LoadCarrierModel *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__LoadCarrierModel__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__LoadCarrierModel__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__LoadCarrierModel__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
