// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/Tag.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/tag__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__msg__Tag__init(rc_reason_msgs__msg__Tag * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__Tag__fini(msg);
    return false;
  }
  // size
  return true;
}

void
rc_reason_msgs__msg__Tag__fini(rc_reason_msgs__msg__Tag * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // size
}

bool
rc_reason_msgs__msg__Tag__are_equal(const rc_reason_msgs__msg__Tag * lhs, const rc_reason_msgs__msg__Tag * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // size
  if (lhs->size != rhs->size) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__Tag__copy(
  const rc_reason_msgs__msg__Tag * input,
  rc_reason_msgs__msg__Tag * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // size
  output->size = input->size;
  return true;
}

rc_reason_msgs__msg__Tag *
rc_reason_msgs__msg__Tag__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Tag * msg = (rc_reason_msgs__msg__Tag *)allocator.allocate(sizeof(rc_reason_msgs__msg__Tag), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__Tag));
  bool success = rc_reason_msgs__msg__Tag__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__Tag__destroy(rc_reason_msgs__msg__Tag * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__Tag__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__Tag__Sequence__init(rc_reason_msgs__msg__Tag__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Tag * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__Tag *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__Tag), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__Tag__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__Tag__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__Tag__Sequence__fini(rc_reason_msgs__msg__Tag__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__Tag__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__Tag__Sequence *
rc_reason_msgs__msg__Tag__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Tag__Sequence * array = (rc_reason_msgs__msg__Tag__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__Tag__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__Tag__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__Tag__Sequence__destroy(rc_reason_msgs__msg__Tag__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__Tag__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__Tag__Sequence__are_equal(const rc_reason_msgs__msg__Tag__Sequence * lhs, const rc_reason_msgs__msg__Tag__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__Tag__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__Tag__Sequence__copy(
  const rc_reason_msgs__msg__Tag__Sequence * input,
  rc_reason_msgs__msg__Tag__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__Tag);
    rc_reason_msgs__msg__Tag * data =
      (rc_reason_msgs__msg__Tag *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__Tag__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__Tag__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__Tag__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
