// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/DeleteLoadCarriers.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/delete_load_carriers__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `load_carrier_ids`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__init(rc_reason_msgs__srv__DeleteLoadCarriers_Request * msg)
{
  if (!msg) {
    return false;
  }
  // load_carrier_ids
  if (!rosidl_runtime_c__String__Sequence__init(&msg->load_carrier_ids, 0)) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(rc_reason_msgs__srv__DeleteLoadCarriers_Request * msg)
{
  if (!msg) {
    return;
  }
  // load_carrier_ids
  rosidl_runtime_c__String__Sequence__fini(&msg->load_carrier_ids);
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__are_equal(const rc_reason_msgs__srv__DeleteLoadCarriers_Request * lhs, const rc_reason_msgs__srv__DeleteLoadCarriers_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // load_carrier_ids
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->load_carrier_ids), &(rhs->load_carrier_ids)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__copy(
  const rc_reason_msgs__srv__DeleteLoadCarriers_Request * input,
  rc_reason_msgs__srv__DeleteLoadCarriers_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // load_carrier_ids
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->load_carrier_ids), &(output->load_carrier_ids)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__DeleteLoadCarriers_Request *
rc_reason_msgs__srv__DeleteLoadCarriers_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Request * msg = (rc_reason_msgs__srv__DeleteLoadCarriers_Request *)allocator.allocate(sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Request));
  bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Request__destroy(rc_reason_msgs__srv__DeleteLoadCarriers_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__init(rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Request * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__DeleteLoadCarriers_Request *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__fini(rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence *
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * array = (rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__destroy(rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__are_equal(const rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * lhs, const rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__DeleteLoadCarriers_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence__copy(
  const rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * input,
  rc_reason_msgs__srv__DeleteLoadCarriers_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Request);
    rc_reason_msgs__srv__DeleteLoadCarriers_Request * data =
      (rc_reason_msgs__srv__DeleteLoadCarriers_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__DeleteLoadCarriers_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__DeleteLoadCarriers_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__DeleteLoadCarriers_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `return_code`
#include "rc_common_msgs/msg/detail/return_code__functions.h"

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__init(rc_reason_msgs__srv__DeleteLoadCarriers_Response * msg)
{
  if (!msg) {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__init(&msg->return_code)) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(rc_reason_msgs__srv__DeleteLoadCarriers_Response * msg)
{
  if (!msg) {
    return;
  }
  // return_code
  rc_common_msgs__msg__ReturnCode__fini(&msg->return_code);
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__are_equal(const rc_reason_msgs__srv__DeleteLoadCarriers_Response * lhs, const rc_reason_msgs__srv__DeleteLoadCarriers_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__are_equal(
      &(lhs->return_code), &(rhs->return_code)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__copy(
  const rc_reason_msgs__srv__DeleteLoadCarriers_Response * input,
  rc_reason_msgs__srv__DeleteLoadCarriers_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__copy(
      &(input->return_code), &(output->return_code)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__DeleteLoadCarriers_Response *
rc_reason_msgs__srv__DeleteLoadCarriers_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Response * msg = (rc_reason_msgs__srv__DeleteLoadCarriers_Response *)allocator.allocate(sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Response));
  bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Response__destroy(rc_reason_msgs__srv__DeleteLoadCarriers_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__init(rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Response * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__DeleteLoadCarriers_Response *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__fini(rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence *
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * array = (rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__destroy(rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__are_equal(const rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * lhs, const rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__DeleteLoadCarriers_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence__copy(
  const rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * input,
  rc_reason_msgs__srv__DeleteLoadCarriers_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__DeleteLoadCarriers_Response);
    rc_reason_msgs__srv__DeleteLoadCarriers_Response * data =
      (rc_reason_msgs__srv__DeleteLoadCarriers_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__DeleteLoadCarriers_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__DeleteLoadCarriers_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__DeleteLoadCarriers_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
