// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:srv/DetectItems.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rc_reason_msgs/srv/detail/detect_items__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void DetectItems_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_reason_msgs::srv::DetectItems_Request(_init);
}

void DetectItems_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_reason_msgs::srv::DetectItems_Request *>(message_memory);
  typed_message->~DetectItems_Request();
}

size_t size_function__DetectItems_Request__item_models(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::msg::ItemModel> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectItems_Request__item_models(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::msg::ItemModel> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectItems_Request__item_models(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::msg::ItemModel> *>(untyped_member);
  return &member[index];
}

void resize_function__DetectItems_Request__item_models(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::msg::ItemModel> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DetectItems_Request_message_member_array[6] = {
  {
    "pose_frame",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, pose_frame),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "region_of_interest_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, region_of_interest_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "load_carrier_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, load_carrier_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "load_carrier_compartment",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::Compartment>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, load_carrier_compartment),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "item_models",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::ItemModel>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, item_models),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectItems_Request__item_models,  // size() function pointer
    get_const_function__DetectItems_Request__item_models,  // get_const(index) function pointer
    get_function__DetectItems_Request__item_models,  // get(index) function pointer
    resize_function__DetectItems_Request__item_models  // resize(index) function pointer
  },
  {
    "robot_pose",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Pose>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Request, robot_pose),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DetectItems_Request_message_members = {
  "rc_reason_msgs::srv",  // message namespace
  "DetectItems_Request",  // message name
  6,  // number of fields
  sizeof(rc_reason_msgs::srv::DetectItems_Request),
  DetectItems_Request_message_member_array,  // message members
  DetectItems_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  DetectItems_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DetectItems_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectItems_Request_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectItems_Request>()
{
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectItems_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectItems_Request)() {
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectItems_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_items__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void DetectItems_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_reason_msgs::srv::DetectItems_Response(_init);
}

void DetectItems_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_reason_msgs::srv::DetectItems_Response *>(message_memory);
  typed_message->~DetectItems_Response();
}

size_t size_function__DetectItems_Response__items(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::msg::Item> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectItems_Response__items(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::msg::Item> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectItems_Response__items(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::msg::Item> *>(untyped_member);
  return &member[index];
}

void resize_function__DetectItems_Response__items(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::msg::Item> *>(untyped_member);
  member->resize(size);
}

size_t size_function__DetectItems_Response__load_carriers(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::msg::LoadCarrier> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectItems_Response__load_carriers(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::msg::LoadCarrier> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectItems_Response__load_carriers(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::msg::LoadCarrier> *>(untyped_member);
  return &member[index];
}

void resize_function__DetectItems_Response__load_carriers(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::msg::LoadCarrier> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DetectItems_Response_message_member_array[4] = {
  {
    "timestamp",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<builtin_interfaces::msg::Time>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Response, timestamp),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "items",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::Item>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Response, items),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectItems_Response__items,  // size() function pointer
    get_const_function__DetectItems_Response__items,  // get_const(index) function pointer
    get_function__DetectItems_Response__items,  // get(index) function pointer
    resize_function__DetectItems_Response__items  // resize(index) function pointer
  },
  {
    "load_carriers",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::LoadCarrier>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Response, load_carriers),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectItems_Response__load_carriers,  // size() function pointer
    get_const_function__DetectItems_Response__load_carriers,  // get_const(index) function pointer
    get_function__DetectItems_Response__load_carriers,  // get(index) function pointer
    resize_function__DetectItems_Response__load_carriers  // resize(index) function pointer
  },
  {
    "return_code",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_common_msgs::msg::ReturnCode>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectItems_Response, return_code),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DetectItems_Response_message_members = {
  "rc_reason_msgs::srv",  // message namespace
  "DetectItems_Response",  // message name
  4,  // number of fields
  sizeof(rc_reason_msgs::srv::DetectItems_Response),
  DetectItems_Response_message_member_array,  // message members
  DetectItems_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  DetectItems_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DetectItems_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectItems_Response_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectItems_Response>()
{
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectItems_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectItems_Response)() {
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectItems_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

#include "rosidl_runtime_c/service_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_items__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers DetectItems_service_members = {
  "rc_reason_msgs::srv",  // service namespace
  "DetectItems",  // service name
  // these two fields are initialized below on the first access
  // see get_service_type_support_handle<rc_reason_msgs::srv::DetectItems>()
  nullptr,  // request message
  nullptr  // response message
};

static const rosidl_service_type_support_t DetectItems_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectItems_service_members,
  get_service_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<rc_reason_msgs::srv::DetectItems>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectItems_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure that both the request_members_ and the response_members_ are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rc_reason_msgs::srv::DetectItems_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rc_reason_msgs::srv::DetectItems_Response
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectItems)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<rc_reason_msgs::srv::DetectItems>();
}

#ifdef __cplusplus
}
#endif
