// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/SuctionGrasp.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__SuctionGrasp __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__SuctionGrasp __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SuctionGrasp_
{
  using Type = SuctionGrasp_<ContainerAllocator>;

  explicit SuctionGrasp_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->uuid = "";
      this->item_uuid = "";
      this->quality = 0.0;
      this->max_suction_surface_length = 0.0;
      this->max_suction_surface_width = 0.0;
    }
  }

  explicit SuctionGrasp_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : uuid(_alloc),
    item_uuid(_alloc),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->uuid = "";
      this->item_uuid = "";
      this->quality = 0.0;
      this->max_suction_surface_length = 0.0;
      this->max_suction_surface_width = 0.0;
    }
  }

  // field types and members
  using _uuid_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _uuid_type uuid;
  using _item_uuid_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _item_uuid_type item_uuid;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;
  using _quality_type =
    double;
  _quality_type quality;
  using _max_suction_surface_length_type =
    double;
  _max_suction_surface_length_type max_suction_surface_length;
  using _max_suction_surface_width_type =
    double;
  _max_suction_surface_width_type max_suction_surface_width;

  // setters for named parameter idiom
  Type & set__uuid(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->uuid = _arg;
    return *this;
  }
  Type & set__item_uuid(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->item_uuid = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__quality(
    const double & _arg)
  {
    this->quality = _arg;
    return *this;
  }
  Type & set__max_suction_surface_length(
    const double & _arg)
  {
    this->max_suction_surface_length = _arg;
    return *this;
  }
  Type & set__max_suction_surface_width(
    const double & _arg)
  {
    this->max_suction_surface_width = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__SuctionGrasp
    std::shared_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__SuctionGrasp
    std::shared_ptr<rc_reason_msgs::msg::SuctionGrasp_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SuctionGrasp_ & other) const
  {
    if (this->uuid != other.uuid) {
      return false;
    }
    if (this->item_uuid != other.item_uuid) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->quality != other.quality) {
      return false;
    }
    if (this->max_suction_surface_length != other.max_suction_surface_length) {
      return false;
    }
    if (this->max_suction_surface_width != other.max_suction_surface_width) {
      return false;
    }
    return true;
  }
  bool operator!=(const SuctionGrasp_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SuctionGrasp_

// alias to use template instance with default allocator
using SuctionGrasp =
  rc_reason_msgs::msg::SuctionGrasp_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__STRUCT_HPP_
